<?php
defined('BASEPATH') OR exit('No direct script access allowed');
 
class payment_history extends MX_Controller {

	public function __construct(){
		parent::__construct();
		$this->load->model(get_class($this).'_model', 'model');
		permission_view(true);
		if(hashcheck()){
			redirect(PATH);
		}
	}

	public function index(){
		$data = array(
			"result" => $this->model->getPaymentHistory()
		);

		$this->template->title(l('Payment history'));
		$this->template->build('index', $data);
	}

	public function update(){
		permission_view(true);
		$id = (int)get('id');
		$data = array(
			"result"  => $this->model->get('*', PAYMENT_HISTORY, "id = '{$id}'")
		);
		$this->template->title(l('Update Payment history'));
		$this->template->build('update', $data);
	}
	
	public function ajax_update(){
		permission_view(true);
		$id = (int)post("id");

		if(post("last_name") == ""){
			ms(array(
				"st"    => "error",
				"label" => "bg-red",
				"txt"   => l('last name is required')
			));
		}

		if(post("status") == ""){
			ms(array(
				"st"    => "error",
				"label" => "bg-red",
				"txt"   => l('status is required')
			));
		}

		if(post("invoice") == ""){
			ms(array(
				"st"    => "error",
				"label" => "bg-red",
				"txt"   => l('invoice is required')
			));
		}

		if(post("trans_id") == ""){
			ms(array(
				"st"    => "error",
				"label" => "bg-red",
				"txt"   => l('trans_id is required')
			));
		}

		$data = array(
			"last_name"       => post("last_name"),
			"invoice"	  => post("invoice"),
			"trans_id"        => post("trans_id"),
			"payment_status"  => post("status")
		);

		$this->db->update(PAYMENT_HISTORY, $data, array("id" => $id));
		ms(array(
			"st"    => "success",
			"label" => "bg-light-green",
			"txt"   => l('Update successfully')
		));
	}

	public function ajax_action_item(){
		$id = (int)post('id');
		$POST = $this->model->get('*', PAYMENT_HISTORY, "id = '{$id}'");
		if(!empty($POST)){
			switch (post("action")) {
				case 'delete':
					$this->db->delete(PAYMENT_HISTORY, "id = '{$id}'");
					break;
				
				case 'active':
					$this->db->update(PAYMENT_HISTORY, array("status" => 1), "id = '{$id}'");
					break;

				case 'disable':
					$this->db->update(PAYMENT_HISTORY, array("status" => 0), "id = '{$id}'");
					break;
			}
		}

		$json= array(
			'st' 	=> 'success',
			'txt' 	=> l('successfully')
		);

		print_r(json_encode($json));
	}

	public function ajax_action_multiple(){
		$ids =$this->input->post('id');
		if(!empty($ids)){
			foreach ($ids as $id) {
				$POST = $this->model->get('*', PAYMENT_HISTORY, "id = '{$id}'");
				if(!empty($POST)){
					switch (post("action")) {
						case 'delete':
							$this->db->delete(PAYMENT_HISTORY, "id = '{$id}'");
							break;
						case 'active':
							$this->db->update(PAYMENT_HISTORY, array("status" => 1), "id = '{$id}'");
							break;

						case 'disable':
							$this->db->update(PAYMENT_HISTORY, array("status" => 0), "id = '{$id}'");
							break;
					}
				}
			}
		}

		print_r(json_encode(array(
			'st' 	=> 'success',
			'txt' 	=> l('-successfully')
		)));
	}

}
